Bug 87674 - Keyboard shortcuts in Impress
Summary: Keyboard shortcuts in Impress
Status: ASSIGNED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Impress (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: Other All
: medium enhancement
Assignee: Yousuf Philips (jay)
QA Contact:
URL:
Whiteboard: target:5.4.0
Keywords:
Depends on:
Blocks: Shortcuts-Accelerators Impress-UX
  Show dependency treegraph
 
Reported: 2014-12-24 08:43 UTC by Yousuf Philips (jay)
Modified: 2017-07-14 19:21 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) 2014-12-24 08:43:05 UTC
Was checking through impress's keyboard shortcuts and noticed that start from first slide was set to both F5, F9, and Ctrl+F2 and wondered why the duplication.

Was also thinking that it would be useful to have shortcut keys to jump between the various views.

And finally it would also be useful to have a shortcut key to add a new slide. A user in the impress survey had suggested it be Ctrl+M (like MSO) rather than that it being assigned to .uno:ResetAttributes.
Comment 1 Cor Nouws 2014-12-24 10:36:12 UTC
(In reply to Jay Philips from comment #0)
> Was checking through impress's keyboard shortcuts and noticed that start
> from first slide was set to both F5, F9, and Ctrl+F2 and wondered why the
> duplication.

Hmm, interesting. 
No idea where F9 and Ctrl+F2 come from, so I wouldn't touch them

> Was also thinking that it would be useful to have shortcut keys to jump
> between the various views.

If possible yes. The menu View > .. works with shortcuts too of course.

> And finally it would also be useful to have a shortcut key to add a new
> slide. A user in the impress survey had suggested it be Ctrl+M (like MSO)
> rather than that it being assigned to .uno:ResetAttributes.

Ctrl+M is general among all modules. So I would suggest not to use that.

Cheers
Cor
Comment 2 Yousuf Philips (jay) 2014-12-24 12:04:15 UTC
(In reply to Cor Nouws from comment #1)
> > Was also thinking that it would be useful to have shortcut keys to jump
> > between the various views.
> 
> If possible yes. The menu View > .. works with shortcuts too of course.

Any suggestions to what you'd like to use, as i'm not a heavy keyboard user.

> > And finally it would also be useful to have a shortcut key to add a new
> > slide. A user in the impress survey had suggested it be Ctrl+M (like MSO)
> > rather than that it being assigned to .uno:ResetAttributes.
> 
> Ctrl+M is general among all modules. So I would suggest not to use that.

Well it seems Draw/Impress doesnt have a command .uno:ResetAttributes, so this has been broken since 3.3.0. It should have been set to .uno:SetDefault like is available in the menu bar and context menu, so as it hasnt worked in the history of LO, maybe its worth using this for new slide. :D
Comment 3 Robinson Tryon (qubit) 2016-08-25 04:44:48 UTC
We're replacing our use of the 'ux-advise' component with a keyword:
 Component -> LibreOffice
 Add Keyword: needsUXEval

[NinjaEdit]
Comment 4 Heiko Tietze 2017-04-18 13:39:39 UTC
F5/F9 duplication is weird. Powerpoint uses F5 to start from beginning and Shift+F5 from current as we do. So unlike Cor I'm in favor to eliminate F9 and ctrl+F2 (easy to revert, though).

Global shortcuts for the views might be too much. We have hotkeys (alt+V, alt+N/O/D/_N_ (again)/A (missing Notes), the modes tab bar is there, and means to deal with some views in the sidebar. On the other hand it may be handy to switch between master slides and normal view. No shortcut for this function in Powerpoint.

Add (aka new) slide is definitely worth a shortcut. The similar function on Calc is Insert Sheet, and on Writer perhaps Page break. So how about ctrl+enter? Powerpoint has ctrl+M for this.
Comment 5 Yousuf Philips (jay) 2017-04-18 19:38:46 UTC
Patch - https://gerrit.libreoffice.org/#/c/36647/

(In reply to Heiko Tietze from comment #4)
> F5/F9 duplication is weird. Powerpoint uses F5 to start from beginning and
> Shift+F5 from current as we do. So unlike Cor I'm in favor to eliminate F9
> and ctrl+F2 (easy to revert, though).

Done

> Global shortcuts for the views might be too much. We have hotkeys (alt+V,
> alt+N/O/D/_N_ (again)/A (missing Notes), the modes tab bar is there, and
> means to deal with some views in the sidebar. On the other hand it may be
> handy to switch between master slides and normal view. No shortcut for this
> function in Powerpoint.

Well maybe it might be too much for all of them, but you are agreeing that master slide would be good to have one. @Stuart, @Sophie, @Regina: What do you guys think of having shortcuts for the various views, even if its just the most important ones? Shortcut suggestions would also be helpful. :D

> Add (aka new) slide is definitely worth a shortcut. The similar function on
> Calc is Insert Sheet, and on Writer perhaps Page break. So how about
> ctrl+enter? Powerpoint has ctrl+M for this.

Done. Might be useful to have shortcuts for clone and delete slide as well. Was thinking about shortcuts like Ctrl + plus, Ctrl + minus and Ctrl + multiply. :D
Comment 6 Heiko Tietze 2017-04-19 07:21:37 UTC Comment hidden (no-value)
Comment 7 Heiko Tietze 2017-04-19 07:26:26 UTC
(In reply to Yousuf Philips (jay) from comment #5)
> Done. Might be useful to have shortcuts for clone and delete slide as well.
> Was thinking about shortcuts like Ctrl + plus, Ctrl + minus and Ctrl +
> multiply. :D

Wouldn't assign a shortcut to delete because it's a destructive function. And duplicate is usually done per ctrl+D. If you go with special characters such as +,- etc. it may not work on some keyboard layouts.
Comment 8 Cor Nouws 2017-04-19 07:46:28 UTC
(In reply to Yousuf Philips (jay) from comment #5)
> Patch - https://gerrit.libreoffice.org/#/c/36647/
> 
> (In reply to Heiko Tietze from comment #4)
> > F5/F9 duplication is weird. Powerpoint uses F5 to start from beginning and
> > Shift+F5 from current as we do. So unlike Cor I'm in favor to eliminate F9
> > and ctrl+F2 (easy to revert, though).
> 
> Done
> 
> > Global shortcuts for the views might be too much. We have hotkeys (alt+V,
> > alt+N/O/D/_N_ (again)/A (missing Notes), the modes tab bar is there, and
> > means to deal with some views in the sidebar. On the other hand it may be
> > handy to switch between master slides and normal view. No shortcut for this
> > function in Powerpoint.
> 
> Well maybe it might be too much for all of them, but you are agreeing that
> master slide would be good to have one. @Stuart, @Sophie, @Regina: What do
> you guys think of having shortcuts for the various views, even if its just
> the most important ones? Shortcut suggestions would also be helpful. :D
> 
> > Add (aka new) slide is definitely worth a shortcut. The similar function on
> > Calc is Insert Sheet, and on Writer perhaps Page break. So how about
> > ctrl+enter? Powerpoint has ctrl+M for this.
> 
> Done.

Sorry that I've missed this. And maybe misunderstand? But since Ctrl+M is clear direct formatting (in Draw, Impress, Calc, Writer) it is IMO undesired and inconsistent to give it a different function here.

> Might be useful to have shortcuts for clone and delete slide as well.

Are these thought to work both the side pane and in the editing/main pane?

> Was thinking about shortcuts like Ctrl + plus, Ctrl + minus and Ctrl +
> multiply. :D

Personally I would love to have Ctrl++ and Ctrl+- handle zoom in and zoom out, as in a browser. But since that already conflicts with insert/delete in Calc, I won't argue against it :)
Comment 9 Cor Nouws 2017-04-19 07:47:08 UTC Comment hidden (obsolete)
Comment 10 Regina Henschel 2017-04-19 10:06:47 UTC
F5 was introduced to please persons switching from PowerPoint, F9 was kept to please StarOffice/OpenOffice users. It was a full discussion from OOo1 to OOo2.

I would not change any existing shortcut key without a very strong need. It frustrates users, when they can no longer use their trained shortcut keys and produces a lot of unnecessary work for documentation and translation.

For me a better approach would be, to improve the design of the customize dialog.
Comment 11 Cor Nouws 2017-04-19 12:41:42 UTC Comment hidden (no-value)
Comment 12 Yousuf Philips (jay) 2017-04-20 03:09:08 UTC
(In reply to Cor Nouws from comment #8)
> Sorry that I've missed this. And maybe misunderstand? But since Ctrl+M is
> clear direct formatting (in Draw, Impress, Calc, Writer) it is IMO undesired
> and inconsistent to give it a different function here.

So any suggestion of an alternative shortcut that you think would be good for inserting a new slide?

> Are these thought to work both the side pane and in the editing/main pane?

Yes it should work everywhere.

> Personally I would love to have Ctrl++ and Ctrl+- handle zoom in and zoom
> out, as in a browser. But since that already conflicts with insert/delete in
> Calc, I won't argue against it :)

Seems that these are already taken up in impress with shape/object arrangement backwards and forwards functions. :D

(In reply to Regina Henschel from comment #10)
> F5 was introduced to please persons switching from PowerPoint, F9 was kept
> to please StarOffice/OpenOffice users. It was a full discussion from OOo1 to
> OOo2.

Thanks for the insight. Any idea why Ctrl+F2 was also there?

> I would not change any existing shortcut key without a very strong need. It
> frustrates users, when they can no longer use their trained shortcut keys
> and produces a lot of unnecessary work for documentation and translation.

The strong need is to reduce duplication and free up shortcut keys, especially single key shortcuts, for other important functions. Users have the ability to change shortcuts if they dislike the default ones, so this isnt isnt a limiting factor. About documentation and translation, it only mentions F5.

https://help.libreoffice.org/Impress/Slide_Show_1

> For me a better approach would be, to improve the design of the customize
> dialog.

We have a GSoC student who will likely be working on that in the coming months. Would you be interested in assisting with mentoring?
Comment 13 Regina Henschel 2017-04-21 21:14:49 UTC
(In reply to Yousuf Philips (jay) from comment #12)
> 
> Thanks for the insight. Any idea why Ctrl+F2 was also there?

Yes. That was the only shortcut key in StarOffice 5.2 to start a presentation and it was kept in OOo1 for users switching from StarOffice, now nearly 17 years ago.
Comment 14 Heiko Tietze 2017-04-21 21:21:28 UTC
(In reply to Regina Henschel from comment #10 & comment #13)

> I would not change any existing shortcut key without a very strong need.
> ...
> ...now nearly 17 years ago.

I would recommend to clean up the shortcuts with a proper announcement and a good customization to back up the oldies. Plus, we should introduce extensions for the customization so that old behavior is just a click away.
Comment 15 Regina Henschel 2017-04-21 22:22:13 UTC
(In reply to Yousuf Philips (jay) from comment #12)
> (In reply to Cor Nouws from comment #8)
> > Sorry that I've missed this. And maybe misunderstand? But since Ctrl+M is
> > clear direct formatting (in Draw, Impress, Calc, Writer) it is IMO undesired
> > and inconsistent to give it a different function here.
> 
> So any suggestion of an alternative shortcut that you think would be good
> for inserting a new slide?

Are you sure you need a new shortcut key for "new slide". Try the workflow with Ctrl+Enter as described in the help.
Comment 16 Yousuf Philips (jay) 2017-04-21 23:08:00 UTC
(In reply to Heiko Tietze from comment #14)
> I would recommend to clean up the shortcuts with a proper announcement and a
> good customization to back up the oldies. Plus, we should introduce
> extensions for the customization so that old behavior is just a click away.

The new shortcuts will be announced in the release notes, as has been done previously with added/modified shortcuts in writer and calc. If you have other shortcuts that you think should be added/modified, please let me know. I've filed bug 107346 to solve the issue of customization.

(In reply to Regina Henschel from comment #15)
> Are you sure you need a new shortcut key for "new slide". Try the workflow
> with Ctrl+Enter as described in the help.

As Ctrl+Enter isnt mentioned next to the command in the menubar, its discoverability is very low and the shortcut only works in the slide pane.
Comment 17 Regina Henschel 2017-04-22 13:20:20 UTC
(In reply to Yousuf Philips (jay) from comment #16)
> 
> As Ctrl+Enter isnt mentioned next to the command in the menubar, its
> discoverability is very low

Yes indeed, all the shortcuts, which are not connected to an uno-command are hard to discover. 

>  and the shortcut only works in the slide pane.

No, it is designed for the working area and had already worked in OOo versions, which do not had a slide pane.
The workflow is: Start with Title slide - Ctrl+Enter - write Title - Ctrl+Enter - write Subtitle - Ctrl Enter (which makes the new slide) - Strg+F6 (to go back to working area) - Ctrl Enter - write Title - Ctrl+Enter - write list - Ctrl Enter - Strg+F6 - Ctrl Enter - write Title and so on.

But I agree, having a slide pane, the slide pane gets focus after the slide is inserted and an additional Ctrl+F6 or mouse click is necessary to go back to working area. That might be an error.



Both Ctrl+Shift+Insert and Alt+Insert seem to be currently unused in all applications. Do they have special meanings in some OS? The Insert-key has the advantage, that it is independent from language.
Comment 18 Commit Notification 2017-05-04 13:41:31 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=70b508ce1f74dbcf24edf1f3cb8d0db2c2d4e3b3

tdf#87674 Remove duplicate shortcuts and add shortcut for new slide

It will be available in 5.4.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 19 Cor Nouws 2017-05-04 20:20:52 UTC
(In reply to Yousuf Philips (jay) from comment #12)
> (In reply to Cor Nouws from comment #8)
> > Sorry that I've missed this. And maybe misunderstand? But since Ctrl+M is
> > clear direct formatting (in Draw, Impress, Calc, Writer) it is IMO undesired
> > and inconsistent to give it a different function here.
> 
> So any suggestion of an alternative shortcut that you think would be good
> for inserting a new slide?

Ctrl+Shift+Insert or Alt+Insert

I think breaking the consistent important Ctrl+M meaning, is something worth to avoid
Comment 20 Yousuf Philips (jay) 2017-05-04 21:12:31 UTC
(In reply to Cor Nouws from comment #19)
> Ctrl+Shift+Insert or Alt+Insert

Inserting a slide is one of the highest used function in impress so having a 3 sequence keystroke is not an option. Alt+Insert isnt a good option either as Insert isnt easily accessible on may non-full keyboards.

> I think breaking the consistent important Ctrl+M meaning, is something worth
> to avoid

As mentioned in comment 2, Ctrl+M to reset formatting has been broken since 3.3 (6+ years) which clearly shows nobody is missing the use of this shortcut. Resetting formatting isnt a highly used feature in impress as there isnt a huge clash between direct formatting and styles, as you do in writer, and according to the OOo stats, most users the contextual menu to activate this option.

Then we have the shortcut being highly used in MSO, WPS, Google Docs[1], etc. for inserting a slide, so its an ideal choice to do the same rather than ask users who are switching to manually change it themselves[2].

[1] https://support.google.com/docs/answer/1696717?hl=en
[2] https://forum.openoffice.org/en/forum/viewtopic.php?f=10&t=17382
Comment 21 Timur 2017-05-12 16:19:43 UTC Comment hidden (obsolete)
Comment 22 Timur 2017-05-12 16:25:40 UTC
There are multiple issues here. 
I'm interested in shortcut keys for Display Views and came across this on looking to file a new bug for that. 
Display Views in Impress since OO don't have shortcut keys (except for slide show) but they would come handy at least for: Normal, Outline, Notes, Slide Sorter, and for masters it would be even better. But masters should be used less often I guess. 
I came on this creating a presentation with notes and it was daunting to use menu each time to go around from Normal to Notes. And that's only option because of Bug 33603 and Bug 84703.
Could Ctrl+Shift be used? Like Ctrl+Shift+M for Normal (since N is not available), Ctrl+Shift+O for Outline, Ctrl+Shift+E for Notes, Ctrl+Shift+D for Slide Sorter. 

Also, like other menu commands, Notes should have a letter for keyboard access. Only E is free in View.  

This should either be dealt here or open as a new bug (with comments from here) so this one is kept only for duplicate shortcuts and add shortcut for new slide.
Comment 23 Yousuf Philips (jay) 2017-05-13 00:04:48 UTC
(In reply to Timur from comment #22)
> Display Views in Impress since OO don't have shortcut keys (except for slide
> show) but they would come handy at least for: Normal, Outline, Notes, Slide
> Sorter, and for masters it would be even better. But masters should be used
> less often I guess. 

So i checked the OOo stats for the views and here is the order based on their activation.

1) Normal          - 3,732
2) Slide Master    - 3,073
3) Slide Sorter    - 1,453
4) Outline         - 1,096
5) Notes           -   377
6) Handout Master  -   256
7) Notes Master    -   159

I would have guessed this might be the order, as i see Benjamin (basic user) primarily using Normal and Slide Master and possibly Slide Sorter if reorganization is needed that would be difficult in Normal view. Eve (advanced user) would use the same ones as Benjamin, though she would use Slide Sorter more often as she would be regularly dealing with presentations with many slides, and she would use Outline for easily creating a new presentation and seeing it in an overview, as well as Notes to assist in her live presentation.

> I came on this creating a presentation with notes and it was daunting to use
> menu each time to go around from Normal to Notes. And that's only option
> because of Bug 33603 and Bug 84703.

Yes with bug 33603 unresolved, i can see Eve wanting to easy switch between Normal and Notes, and see her utilizing it alot less once the bug is resolved.

> Could Ctrl+Shift be used? Like Ctrl+Shift+M for Normal (since N is not
> available), Ctrl+Shift+O for Outline, Ctrl+Shift+E for Notes, Ctrl+Shift+D
> for Slide Sorter. 

I think Ctrl+Shift is good, Powerpoint also uses it for changing view, but would recommend primarily using the numbers row as they are easier to hit and they are next to each other. So i'd suggest Ctrl+Shift+~ for Normal, Ctrl+Shift+1 for Outline, Ctrl+Shift+2 for Slide Sorter, Ctrl+Shift+3 for Notes, and Ctrl+Shift+M/Ctrl+Shift+0 for Slide Master.

> Also, like other menu commands, Notes should have a letter for keyboard
> access. Only E is free in View.  

Put in a patch to make each of the modes have a unique letter.
https://gerrit.libreoffice.org/37564
Comment 24 Mark Hung 2017-05-13 04:51:18 UTC
Hi Yusuf,

> > to avoid
> 
> As mentioned in comment 2, Ctrl+M to reset formatting has been broken since
> 3.3 (6+ years) which clearly shows nobody is missing the use of this
> shortcut. Resetting formatting isnt a highly used feature in impress as

This doesn't hold. I do care and fixed this in 5.3.0.2. And I certainly feel that consistency is important. I don't think I see consensus in the discussion. What's the opinion of UX people about this?


> there isnt a huge clash between direct formatting and styles, as you do in
> writer, and according to the OOo stats, most users the contextual menu to
> activate this option.

My daily usage of Impress involves importing ppt or pptx, where many times I have to reset direct formatting to default because changing style doesn't work. My intention is to make the workflow as effective as in Writer. You're patch associate Ctrl+M with new slide but doesn't assign any key binding to that.

> 
> Then we have the shortcut being highly used in MSO, WPS, Google Docs[1],
> etc. for inserting a slide, so its an ideal choice to do the same rather
> than ask users who are switching to manually change it themselves[2].
> 
> [1] https://support.google.com/docs/answer/1696717?hl=en
> [2] https://forum.openoffice.org/en/forum/viewtopic.php?f=10&t=17382
Comment 25 Cor Nouws 2017-05-13 08:38:29 UTC
(In reply to Yousuf Philips (jay) from comment #0)

> And finally it would also be useful to have a shortcut key to add a new
> slide. A user in the impress survey had suggested it be Ctrl+M (like MSO)
> rather than that it being assigned to .uno:ResetAttributes.

Sorry that I thought this had been properly prepared from the start. But looking for what is available/assigned, I see there already is a simple shortcut to add a new slide already for ages:

"Ctrl+Enter
Moves to the next text object on the slide.
If there are no text objects on the slide, or if you reached the last text object, a new slide is inserted after the current slide. The new slide uses the same layout as the current slide."

The only thing is that it can be annoying that it moves along all text objects first.
So improvement could be Ctrl+Shift+Enter either for New slide, or for Moving to the next text object.
Accept it or not: considering the fact that New slide is used often and that the working of Ctrl+M is/was broken, as a sort of argument to break consistency makes no sense.
Comment 26 Yousuf Philips (jay) 2017-05-13 11:50:36 UTC
(In reply to Mark Hung from comment #24)
> Hi Yusuf,

Hi Mark,

> This doesn't hold. I do care and fixed this in 5.3.0.2. And I certainly feel
> that consistency is important. I don't think I see consensus in the
> discussion. What's the opinion of UX people about this?

Yes 'nobody' wasnt accurate at the time of comment 20, though it was correct when comment 2 was written, as you were somebody who cared enough to file a bug about it. Consistency is always a good thing, but we do need to cater each app to what best suits it, both in UI and shortcuts, and highly used actions take priority when it comes to shortcuts (e.g. F5 in impress starts the slide show, while F5 in writer and calc open navigator).

> My daily usage of Impress involves importing ppt or pptx, where many times I
> have to reset direct formatting to default because changing style doesn't
> work. My intention is to make the workflow as effective as in Writer. You're
> patch associate Ctrl+M with new slide but doesn't assign any key binding to
> that.

Yes ideally we should have a shortcut for it, so i've assigned Ctrl + Shift + M.
https://gerrit.libreoffice.org/37571

For those who are curious, according to the OOo stats, as the shortcut didnt work at that time as well, 80% of users used the context menu and 20% used the menu bar to reset direct formatting.

(In reply to Cor Nouws from comment #25)
> "Ctrl+Enter
> Moves to the next text object on the slide.
> If there are no text objects on the slide, or if you reached the last text
> object, a new slide is inserted after the current slide. The new slide uses
> the same layout as the current slide."

We had discussed Ctrl+Enter starting in comment 15. :D

> So improvement could be Ctrl+Shift+Enter either for New slide, or for Moving
> to the next text object.

Both Ctrl+Enter and Ctrl+Shift+Enter arent suitable for users who use keyboard shortcuts with their left hand and mouse with their right hand as ctrl and enter are to far apart.
Comment 27 Cor Nouws 2017-05-13 12:30:55 UTC
(In reply to Yousuf Philips (jay) from comment #26)

> We had discussed Ctrl+Enter starting in comment 15. :D

To me that doesn't read like a normal discussion. More that you found 'reasons' not to look at the idea, and ignored a next reply but just committed a patch.
Comment 28 Commit Notification 2017-05-15 18:30:02 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=509c91aca5a9e89e9453082486ac7d67f649a7f5

tdf#87674 Ctrl + Shift + M for Default Formatting

It will be available in 5.4.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 29 Xisco Faulí 2017-07-14 14:02:58 UTC
Polite ping: is this bug fixed? if so, please close it as RESOLVED FIXED
Comment 30 Yousuf Philips (jay) 2017-07-14 19:21:30 UTC
(In reply to Xisco Faulí from comment #29)
> Polite ping: is this bug fixed? if so, please close it as RESOLVED FIXED

Not not fully fixed.